const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const receipt_lines = sequelize.define(
    'receipt_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

unit_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

memo: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  receipt_lines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
























































//end loop



    db.receipt_lines.belongsTo(db.receipts, {
      as: 'receipt',
      foreignKey: {
        name: 'receiptId',
      },
      constraints: false,
    });

    db.receipt_lines.belongsTo(db.items, {
      as: 'item',
      foreignKey: {
        name: 'itemId',
      },
      constraints: false,
    });

    db.receipt_lines.belongsTo(db.lots, {
      as: 'lot',
      foreignKey: {
        name: 'lotId',
      },
      constraints: false,
    });

    db.receipt_lines.belongsTo(db.serial_numbers, {
      as: 'serial_number',
      foreignKey: {
        name: 'serial_numberId',
      },
      constraints: false,
    });

    db.receipt_lines.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.receipt_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.receipt_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return receipt_lines;
};


